<?php
/**
 * BroadcastLayout
 *
 * PHP version 7.2
 *
 * @category Class
 * @package  MuxPhp
 * @author   Mux API team
 * @link     https://docs.mux.com
 */

/**
 * Mux API
 *
 * Mux is how developers build online video. This API encompasses both Mux Video and Mux Data functionality to help you build your video-related projects better and faster than ever before.
 *
 * The version of the OpenAPI document: v1
 * Contact: devex@mux.com
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 5.0.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace MuxPhp\Models;
use \MuxPhp\ObjectSerializer;

/**
 * BroadcastLayout Class Doc Comment
 *
 * @category Class
 * @description The layout used when broadcasting the space.  The &#x60;gallery&#x60; layout will show participants in a grid that automatically resizes each participant’s stream to best fit up to 10 participants in the window. The &#x60;active-speaker&#x60; layout will show only the current active speaker, without a border. The &#x60;crop&#x60; layout uses as much of the available space as possible to show the participant&#39;s stream.  Defaults to &#x60;gallery&#x60; if not set.
 * @package  MuxPhp
 * @author   Mux API team
 * @link     https://docs.mux.com
 */
class BroadcastLayout
{
    /**
     * Possible values of this enum
     */
    public const GALLERY = 'gallery';
    public const ACTIVE_SPEAKER = 'active-speaker';
    public const CROP = 'crop';
    
    /**
     * Gets allowable values of the enum
     * @return string[]
     */
    public static function getAllowableEnumValues()
    {
        return [
            self::GALLERY,
            self::ACTIVE_SPEAKER,
            self::CROP,
        ];
    }
}


